import fs from"fs";import{exec}from"child_process";import{exit}from"process";import fetch from"node-fetch";import JSZip from"jszip";import puppeteer from"puppeteer";import{Command}from"commander";process.env.NODE_TLS_REJECT_UNAUTHORIZED="0";const apiURL="http://localhost/api",statexplorerUrl="http://localhost/statexplorer";function logToConsole(e){var o=new Date,t=`${o.getFullYear()}-${o.getMonth()}-${o.getDate()} ${o.getHours()}:${o.getMinutes()}:${o.getSeconds()}`;console.log(`${t} ${e}`)}function errToConsole(e){var o=new Date,t=`${o.getFullYear()}-${o.getMonth()}-${o.getDate()} ${o.getHours()}:${o.getMinutes()}:${o.getSeconds()}`;console.error(`${t} ${e}`)}async function getPageContentsWithPuppeteer(e,o){var t=null;try{logToConsole("Launching browser"),t=await puppeteer.launch({args:["--no-sandbox"],headless:!0}),logToConsole("Creating page");const n=await t.newPage();logToConsole("Loading initial page"),await n.goto(e),logToConsole("Loading results"),await n.waitForSelector("#export-finished"),logToConsole(`Converting to ${o}`);var a=[];switch(o){case"pdf":a.push(await n.pdf({displayHeaderFooter:!1,printBackground:!0,format:"A4",landscape:!0}));break;case"csv":a=await n.evaluate((()=>Promise.resolve(window.csvs)));break;case"html":default:a.push(await n.content())}return logToConsole("Closing browser"),await t.close(),a}catch(e){errToConsole(e.message),t&&await driver.close(),exit(1)}}async function getApiToken(){return new Promise((async(e,o)=>{try{var t=new URLSearchParams;t.append("key","2c86b708-35ea-48b5-8162-53e15d961293");var a=await fetch(`${apiURL}/authenticate`,{method:"POST",body:t});if(!a.ok)return errToConsole("Unable to get token"),void o(new Error("request failed"));var n=await a.json();if("success"===n.status)return void e(n.data.token);errToConsole(n.message),o(new Error(n.status))}catch(e){o(e)}}))}async function getMailFromAsync(){return new Promise((async(e,o)=>{try{var t=await getApiToken();logToConsole(`Got api token ${t}`);var a=new URLSearchParams;a.append("token",t),a.append("module","system_misc"),a.append("name","fromemail");var n=await fetch(`${apiURL}/get_setting`,{method:"POST",body:a});if(!n.ok)return errToConsole("Unable to get mail from"),void o(new Error("request failed"));var r=await n.json();if("success"===r.status)return void e(r.data);errToConsole(r.message),o(new Error(r.status))}catch(e){o(e)}}))}function storeAttachementsAsync(e,o,t){return new Promise((async a=>{const n=`${t}.zip`;fs.existsSync(n)&&fs.unlinkSync(n);var r=new JSZip;switch(e){case"csv":for(var s of o){logToConsole(`Creating attachement ${l=`export_${s.name}.csv`}`),r.file(l,s.content)}break;case"html":case"pdf":default:for(var i=0;i<o.length;i++){var l;logToConsole(`Creating attachement ${l=`export_${i}.${e}`}`),r.file(l,o[i])}}r.generateNodeStream({type:"nodebuffer",streamFiles:!0}).pipe(fs.createWriteStream(n)).on("finish",(function(){a(n)}))}))}async function buildMailCommand(e,o,t){var a="";try{logToConsole(`Got mailfrom ${a=await getMailFromAsync()}`)}catch(e){errToConsole("Unable to get mail from. Using default.",JSON.stringify(e))}var n="";switch(e){case"debian":n=`echo "${body}" | mail ${""!==a?`-a "from: ${a}" -r "${a}"`:""} -A "${o}" -s "${subject}" ${t.replace(/,/g," ").replace(/;/g," ")}`;break;default:n=`echo "${body}" | mailx ${""!==a?`-S "from=${a}" -r "${a}"`:""} -a "${o}" -s "${subject}" ${t.replace(/,/g," ").replace(/;/g," ")}`}return n}async function exportAndMail(e,o,t,a,n,r,s){try{const r=await getPageContentsWithPuppeteer(o,a),s=await storeAttachementsAsync(a,r,n);if(""!==t){const o=await buildMailCommand(e,s,t);logToConsole(o),exec(o,((e,o,a)=>{fs.unlinkSync(s),e&&(logToConsole("Done, but failed to send file"),logToConsole(o,a),exit(1)),logToConsole("Done and sent to "+t),exit(0)}))}else logToConsole(`Done, stored to ${s}`),exit(0)}catch(e){errToConsole(e.message),exit(1)}}const args=new Command;args.version("2.0").requiredOption("-d, --distro <name>","Distro name (centos/debian)").option("-l, --lang <code>","Language code (en_US, fr_FR, etc)","en_US").requiredOption("-p, --plugins <names>","Plugins to export, separated by a coma").option("-u, --userid <int>","User identifier, 1 for admin","1").requiredOption("-f, --filter <name>","Filter name to use").option("-e, --emails <recipient>","Email address to send this report. you can set more than 1 addreess, separated by a coma (,)","").option("-t, --filetype <type>","Kind of file to generate (csv, html, pdf). File will be zipped.","html").option("-n, --filename <name>","Name of zipped file","/tmp/statexplorer_autoexport").option("-s, --subject <text>","Email subject","Statexplorer autoexport").option("-b, --body <text>","Email body","Please find your export in attachement. Thank you for using Statexplorer"),args.addHelpText("after",'\n\nIf you specify emails option, the generated file will be deleted after beeing sent. \nIf you don\'t specify emails option, the generate file will be kept indefinitely. \nExtensions ".zip" will be automatically added to filename. you should NOT add it manually. \nBy default, if not set, generated file will be /tmp/statexplorer_autoexport\n\n'),args.parse();const options=args.opts();logToConsole(JSON.stringify(options,null,"  "));const distro=options.distro,lang=options.lang,plugins=JSON.stringify(options.plugins.split(",")),userid=options.userid,filter=options.filter,emails=options.emails,filetype=options.filetype,filename=options.filename,subject=options.subject,body=options.body,url=`${statexplorerUrl}/exporttopdf.php?lang=${lang}&plugins=${plugins}&userid=${userid}&filter=${filter}`;exportAndMail(distro,url,emails,filetype,filename,subject,body);
